/* Taken from KDE 2.1 CVS as of 2001/01/26,
 * removed all KDE specific things. This class is
 * inherently useful for Qt/Embedded applications...
 *                                          --bero
 */
/* This file is part of the KDE libraries
    Copyright (C) 1997 Christian Czezakte (e9025461@student.tuwien.ac.at)

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/
//
//  KPROCESSCONTROLLER -- A helper class for QextProcess
//
//  version 0.3.1, Jan 8th 1997
//
//  (C) Christian Czezatke
//  e9025461@student.tuwien.ac.at
//

#ifndef __QEXTPROCCTRL_H__
#define __QEXTPROCCTRL_H__


#include <qsocketnotifier.h>
#include "qextprocess.h"

class QextProcessControllerPrivate;

/**
 * @short Used internally by @ref QextProcess
 * @internal
 * @author Christian Czezakte <e9025461@student.tuwien.ac.at> (as KProcess)
 *
 *  A class for internal use by QextProcess only. -- Exactly one instance
 *  of this class is generated by the first instance of QextProcess that is
 *  created (a pointer to it gets stored in @ref theQextProcessController ).
 *
 * This class takes care of the actual (UN*X) signal handling.
*/
class QextProcessController : public QObject
{
  Q_OBJECT

public:
  QextProcessController();
  ~QextProcessController(); 
  //CC: WARNING! Destructor Not virtual (but you don't derive classes from this anyhow...)

  QList<QextProcess> *processList;

 public slots:

 void slotDoHousekeeping(int socket);

public:
 	
 	/**
	 * Only a single instance of this class is allowed at a time,
	 * and this static variable is used to track the one instance.
	 */
	static QextProcessController *theQextProcessController;

private:

  static void theSigCHLDHandler(int signal);
  // handler for sigchld

  int fd[2];
  QSocketNotifier *notifier;

  // Disallow assignment and copy-construction
  QextProcessController( const QextProcessController& );
  QextProcessController& operator= ( const QextProcessController& );

  QextProcessControllerPrivate *d;
};



#endif

