#include "qmkbootdisk.moc"
#include "qextprocess.h"
#include "progress.h"
#include "Files.h"
#include <qheader.h>
#include <qstringlist.h>
#include <qhbox.h>
QMkBootDisk::QMkBootDisk(QWidget *parent, const char *name, bool modal, WFlags f):QDialog(parent, name, modal, f)
{
	_ready=false;
	Layout=new QGridLayout(this);
	Header=new QLabel(tr("<b><big><center>Boot Disk Creation</center></big></b>"), this);
	Layout->addMultiCellWidget(Header, 0, 0, 0, 1);
	Disk_lbl=new QLabel(tr("Create boot disk on &drive:"), this);
	Layout->addWidget(Disk_lbl, 1, 0);
	Disk=new QComboBox(this);
	Disk_lbl->setBuddy(Disk);
	for(int i=0; i<4; i++) {
		QString n;
		n.setNum(i);
		Disk->insertItem(QString("/dev/fd%1").arg(n));
	}
	Layout->addWidget(Disk, 1, 1);
	Kernel_lbl=new QLabel(tr("Use &kernel version:"), this);
	Layout->addWidget(Kernel_lbl, 2, 0);
	Kernel=new QComboBox(this);
	Kernel_lbl->setBuddy(Kernel);
	QStringList kernels=Files::glob("/boot/vmlinuz-*", (Files::Types)(Files::File|Files::Link), false, false);
	for(QStringList::Iterator i=kernels.begin(); i!=kernels.end(); i++)
		Kernel->insertItem((*i).mid(14));
	Layout->addWidget(Kernel, 2, 1);
	QHBox *buttons=new QHBox(this);
	OK=new QPushButton(tr("&OK"), buttons);
	Cancel=new QPushButton(tr("&Cancel"), buttons);
	Layout->addMultiCellWidget(buttons, 3, 3, 0, 1);
	connect(OK, SIGNAL(clicked()), this, SLOT(okClicked()));
	connect(Cancel, SIGNAL(clicked()), this, SLOT(reject()));
	OK->setFocus();
}
void QMkBootDisk::okClicked()
{
	hide();
	QextProcess mkbd;
	mkbd << "/sbin/mkbootdisk" << "--device" << Disk->currentText() << Kernel->currentText();
	mkbd.start(QextProcess::NotifyOnExit, (QextProcess::Communication)(QextProcess::Stdin|QextProcess::Stdout));
	mkbd.writeStdin("\n", 1);
	QDialog *progress=new Progress;
	connect(&mkbd, SIGNAL(processExited(QextProcess*)), progress, SLOT(finished()));
	progress->exec();
	accept();
}
